package com.jiuqi.util.biff;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;

public class BIFFReader extends BIFFFiler {
   private int headSize = 0;

   public BIFFReader() {
   }

   public BIFFReader(Stream stream) {
      super(stream);
   }

   public int getHeadSize() {
      return this.headSize;
   }

   public void setHeadSize(int value) {
      this.headSize = value;
   }

   public void first() throws StreamException {
      this.stream.setPosition((long)this.headSize);
      this.next();
   }

   public void next() throws StreamException {
      if (this.stream.getPosition() >= this.stream.getSize()) {
         this.biff.reset(this.eofSign);
      } else {
         byte sign = this.stream.read();
         int size = this.stream.readInt();
         this.biff.reset(sign);
         if (size > 0) {
            this.biff.getData().copyFrom(this.stream, (long)size);
            this.biff.getData().setPosition(0L);
         }
      }

   }

   public boolean getEOF() {
      return this.biff.getSign() == this.eofSign;
   }
}
